#ifndef LOCK_GUARD_H
#define LOCK_GUARD_H

/*!
  \file
  \brief bNK[hNX

  \author Satofumi KAMIMURA

  $Id: LockGuard.h 439 2009-01-03 05:01:55Z satofumi $
*/

#include <memory>


namespace qrk
{
  class Lock;

  /*!
    \brief bNK[hNX
  */
  class LockGuard
  {
    LockGuard(void);
    LockGuard(const LockGuard& rhs);
    LockGuard& operator = (const LockGuard& rhs);

    void* operator new (size_t);
    void* operator new[] (size_t);

    struct pImpl;
    std::auto_ptr<pImpl> pimpl;

  public:
    /*!
      \brief RXgN^

      \param[in] mutex ~[ebNX
    */
    explicit LockGuard(qrk::Lock& mutex);
    ~LockGuard(void);
  };
}

#endif /* !LOCK_GUARD_H */
