/*!
  \file
  \brief チャットパケット処理の補助

  \author Satofumi KAMIMURA

  $Id: ChatPacketUtils.cpp 809 2009-05-07 00:43:49Z satofumi $
*/

#include "ChatPacketUtils.h"
#include "PacketUtils.h"

using namespace qrk;


Packet qrk::chatPacket(const char* message, ClientId id)
{
  Packet packet(3, 0x00);

  addParameter(packet, "CH");
  addParameter(packet, id);
  addParameter(packet, message);
  packet.push_back(PacketCtrl::EndCharacter);
  setPacketLength(packet);

  return packet;
}


const char* qrk::chatMessage(const Packet& packet)
{
  return &packet[7];
}
